/******************************************************
 *             G-Tronic Robotics                      *
 *  Display LCD 16x2 Hitachi HD44780                  *
 *  Andrea D.P.    04/11/2021                         *
 *  PIC:  16F877A                                     *
 *  Hardware: Micro-GT mini, Micro-GT IDE, TOY-PLC    *
 *  Compiler: XC8 v1.10                               *
 *  IDE: MPLABX v4.0                                  *
 ******************************************************/

//Nota:sono presenti due tipi di Delay a scopo dimostrativo
//Usare quella che interessa e disabilitare l'altra.

#include <xc.h>   //Libreria pricincipale dichiarazione PIC
#include "settaggiXC.h"     //Imposta i fuses

//#define Pulsante1 RB0
//#define LED1 RC0

int count = 0;

#define EN RE0
#define RW RE1
#define RS RE2


void __interrupt() pippo () {
	if (TMR0IF) 
    {
        TMR0IF=0;
        TMR0 = 245;
        count++; 
    }
    
}

void CLOCK(){
	EN=1;
	__delay_ms(1);
	EN=0;
    }

void Init_LCD(){
	RS=0; RW=0; PORTD=0x30; //usa il display in mod. 8 bit
	__delay_ms(15);
	CLOCK();    		//imposto da specifiche tecniche del display
	__delay_ms(10); 		//vanno date in sequenza tre comandi clock()
	CLOCK();
	__delay_ms(10);
	CLOCK();
	__delay_ms(10);
	RS=0; RW=0; PORTD=0x38; //conferma interfaccia a 8 bit e font 5x8
	CLOCK();
	__delay_ms(1);
	RS=0; RW=0; PORTD=0x08; //spegni LCD
	CLOCK();
	__delay_ms(1);
	RS=0; RW=0; PORTD=0x0C; //accendi LCD
	CLOCK();
	__delay_ms(1);
	RS=0; RW=0; PORTD=0x01; //pulisci LCD
	CLOCK();
	__delay_ms(1);
	RS=0; RW=0; PORTD=0x03; //LCD acceso ma toglie cursore e lampeggio
	CLOCK();
	__delay_ms(1);
}

void Clear_LCD(){
	RS=0; RW=0; 
	//PORTD=0x0F;
	PORTD=0x01;
	CLOCK();
	__delay_ms(2); 
}

void VAI(unsigned char r, unsigned char c){unsigned char a=0; //posiziona il cursore
				RS=0; RW=0;
		   		if(r==1){a=c+127;}
		   		if(r==2){a=c+191;}
		   		PORTD=(a);
				CLOCK();
	       		__delay_us(50);}

void SCRIVI(char lettera){
    RS=1; RW=0; PORTD=(lettera); //scrive dove posizionato
	CLOCK();
	__delay_us(50);
}

void FRASE(unsigned char l, unsigned char n, const char* msg1){
	             while(n<=16){VAI(l,n);
			     SCRIVI(*msg1++);
			     n++;
			     }
 n=1;
 }


void Start(){//scrive su LCD la presentazione per alcuni secondi
    FRASE(1,1," G-Tronic 2021  ");
    //__delay_ms(2000);
    FRASE(2,1,"   Test LCD     ");
    __delay_ms(2000);
    Clear_LCD();
}

void main(void) {

    settaggi();
	Init_LCD();
	Clear_LCD();
    __delay_ms(10);
    Start();

    while (1) {        
    
                                                      
    }
}
