/************************************************* 
 * File: SettaggiXC.h                            *
 * G.Tronic Robotics                             *
 * File di settaggio per Micro-GT IDE e mini     *
 * Revision history: V1.0                        *
 *************************************************/

#define _XTAL_FREQ 20000000  //Riferimento usato da XC8 per le delay_ms(x)

//Fuses: Controllare sui databook degli specifici PIC la presenza
//       dei bit da configurare.
//        possibile indicare un pragma per ogni fuses oppure
//       separarli con la virgola come indicato sotto.

#pragma config  WDTE=ON, PWRTE=OFF, CP=OFF, CPD=OFF, BOREN=ON, 
#pragma config  WRT=OFF, LVP=OFF

// I fuses possono essere indicati uno alla volta
#pragma config FOSC = HS // Oscillator Selection bits (HS oscillator)
#pragma config WDTE = ON // Watchdog Timer Enable bit (WDT enabled)
#pragma config PWRTE = OFF // Power-up Timer Enable bit (PWRT disabled)
#pragma config BOREN = ON // Brown-out Reset Enable bit (BOR enabled)
#pragma config LVP = OFF // Low-Voltage (Single-Supply) In-Circuit Serial Programming Enable bit (RB3 is digital I/O, HV on MCLR must be used for programming)
#pragma config CPD = OFF // Data EEPROM Memory Code Protection bit (Data EEPROM code protection off)
#pragma config WRT = OFF // Flash Program Memory Write Enable bits (Write protection off; all program memory may be written to by EECON control)
#pragma config CP = OFF // Flash Program Memory Code Protection bit (Code protection off)
//fine della configurazione


void settaggi(){
    
	TRISA=0xFF;
	TRISB=0b11111111; 
	TRISC = 0b1111;//primo nibble ingressi, lascio libera la seriale
	TRISD = 0; 
	TRISE = 0; 
	PORTD = 0; 
	PORTE = 0; 
	OPTION_REG = 0x80; 
	ADCON1 = 0b10000010;
    
    //OPTION_REG = 0b00010100;	//imposta registro option
	INTCON = 0b10100000;		//imposta registro interrupt
    
   }